use crate::error::Res;
use crate::parser::OrgSource;

mod context;
mod exiting;
mod file_access_interface;
mod global_settings;
mod list;
mod parser_with_context;

 type RefContext<'b, 'g, 'r, 's> = &'b Context<'g, 'r, 's>;
 trait ContextMatcher = for<'b, 'g, 'r, 's> Fn(
    RefContext<'b, 'g, 'r, 's>,
    OrgSource<'s>,
) -> Res<OrgSource<'s>, OrgSource<'s>>;
 type DynContextMatcher<'c> = dyn ContextMatcher + 'c;
 trait Matcher = for<'s> Fn(OrgSource<'s>) -> Res<OrgSource<'s>, OrgSource<'s>>;
#[allow(dead_code)]
 type DynMatcher<'c> = dyn Matcher + 'c;

 use context::Context;
 use context::ContextElement;
 use context::ExitMatcherNode;
 use exiting::ExitClass;
 use file_access_interface::FileAccessInterface;
 use file_access_interface::LocalFileAccessInterface;
 use global_settings::GlobalSettings;
 use list::List;
(crate) use parser_with_context::parser_with_context;
